package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.QueryModel;
import com.sa.ibiz.demo.demo.service.QueryModelService;
import com.sa.ibiz.demo.demo.service.dto.QueryModelSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/querymodel")
public class QueryModelResource
{
	@Autowired
	private QueryModelService service;


	@PostMapping(value = "/checkKey")
	public ResponseEntity<QueryModel> checkKey(@Validated @RequestBody QueryModel data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("实体查询模型[checkKey]操作发生错误","QueryModel",data.getQuerymodelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<QueryModel> create(@Validated @RequestBody QueryModel data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("实体查询模型[create]操作发生错误","QueryModel",data.getQuerymodelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<QueryModel> getDraft(@Validated @RequestBody QueryModel data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("实体查询模型[getDraft]操作发生错误","QueryModel","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<QueryModel> update(@Validated @RequestBody QueryModel data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("实体查询模型[update]操作发生错误","QueryModel",data.getQuerymodelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<QueryModel> remove(@Validated @RequestBody QueryModel data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("实体查询模型[remove]操作发生错误","QueryModel",data.getQuerymodelid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<QueryModel> get(@Validated @PathVariable String id){
		QueryModel data=new QueryModel();
		data.setQuerymodelid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("实体查询模型[get]操作发生错误","QueryModel",id.toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<QueryModel>> searchDefaultPage(@Validated @RequestBody QueryModelSearchFilter filter){
		Page<QueryModel> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<QueryModel>> listDefault(@Validated @RequestBody QueryModelSearchFilter filter){
		List<QueryModel> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
    @PostMapping(value="/searchcurde")
	public ResponseEntity<Page<QueryModel>> searchCurDEPage(@Validated @RequestBody QueryModelSearchFilter filter){
		Page<QueryModel> searchResult = service.searchCurDE(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listcurde")
	public ResponseEntity<List<QueryModel>> listCurDE(@Validated @RequestBody QueryModelSearchFilter filter){
		List<QueryModel> searchResult = service.listCurDE(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
